diff --git a/drivers/event/cnxk/cn10k_worker.h b/drivers/event/cnxk/cn10k_worker.h
index 1e61a6ddf0..5c36540a43 100644
--- a/drivers/event/cnxk/cn10k_worker.h
+++ b/drivers/event/cnxk/cn10k_worker.h
@@ -174,7 +174,6 @@ cn10k_process_vwqe(uintptr_t vwqe, uint16_t port_id, const uint32_t flags,
 					   CNXK_SSO_WQE_SG_PTR);
 		cnxk_nix_mbuf_to_tstamp((struct rte_mbuf *)mbuf, tstamp,
 					flags & NIX_RX_OFFLOAD_TSTAMP_F,
-					flags & NIX_RX_MULTI_SEG_F,
 					(uint64_t *)tstamp_ptr);
 		wqe[0] = (uint64_t *)mbuf;
 		non_vec--;
@@ -266,7 +265,6 @@ cn10k_sso_hws_get_work(struct cn10k_sso_hws *ws, struct rte_event *ev,
 			cnxk_nix_mbuf_to_tstamp((struct rte_mbuf *)mbuf,
 						ws->tstamp,
 						flags & NIX_RX_OFFLOAD_TSTAMP_F,
-						flags & NIX_RX_MULTI_SEG_F,
 						(uint64_t *)tstamp_ptr);
 			gw.u64[1] = mbuf;
 		} else if (CNXK_EVENT_TYPE_FROM_TAG(gw.u64[0]) ==
diff --git a/drivers/event/cnxk/cn9k_worker.h b/drivers/event/cnxk/cn9k_worker.h
index e44422ec25..368baae048 100644
--- a/drivers/event/cnxk/cn9k_worker.h
+++ b/drivers/event/cnxk/cn9k_worker.h
@@ -208,7 +208,6 @@ cn9k_sso_hws_dual_get_work(uint64_t base, uint64_t pair_base,
 			cnxk_nix_mbuf_to_tstamp((struct rte_mbuf *)mbuf,
 						dws->tstamp,
 						flags & NIX_RX_OFFLOAD_TSTAMP_F,
-						flags & NIX_RX_MULTI_SEG_F,
 						(uint64_t *)tstamp_ptr);
 			gw.u64[1] = mbuf;
 		}
@@ -285,7 +284,6 @@ cn9k_sso_hws_get_work(struct cn9k_sso_hws *ws, struct rte_event *ev,
 			cnxk_nix_mbuf_to_tstamp((struct rte_mbuf *)mbuf,
 						ws->tstamp,
 						flags & NIX_RX_OFFLOAD_TSTAMP_F,
-						flags & NIX_RX_MULTI_SEG_F,
 						(uint64_t *)tstamp_ptr);
 			gw.u64[1] = mbuf;
 		}
diff --git a/drivers/net/cnxk/cn10k_rx.h b/drivers/net/cnxk/cn10k_rx.h
index 9694a3080f..45b626b089 100644
--- a/drivers/net/cnxk/cn10k_rx.h
+++ b/drivers/net/cnxk/cn10k_rx.h
@@ -364,7 +364,13 @@ cn10k_nix_cqe_to_mbuf(const struct nix_cqe_hdr_s *cq, const uint32_t tag,
 	*(uint64_t *)(&mbuf->rearm_data) = val;

 	if (flag & NIX_RX_MULTI_SEG_F)
-		nix_cqe_xtract_mseg(rx, mbuf, val, flag);
+		/*
+		 * For multi segment packets, mbuf length correction according
+		 * to Rx timestamp length will be handled later during
+		 * timestamp data process.
+		 * Hence, flag argument is not required.
+		 */
+		nix_cqe_xtract_mseg(rx, mbuf, val, 0);
 	else
 		mbuf->next = NULL;
 }
@@ -452,7 +458,6 @@ cn10k_nix_recv_pkts(void *rx_queue, struct rte_mbuf **rx_pkts, uint16_t pkts,
 				      flags);
 		cnxk_nix_mbuf_to_tstamp(mbuf, rxq->tstamp,
 					(flags & NIX_RX_OFFLOAD_TSTAMP_F),
-					(flags & NIX_RX_MULTI_SEG_F),
 					(uint64_t *)((uint8_t *)mbuf
 								+ data_off));
 		rx_pkts[packets++] = mbuf;
diff --git a/drivers/net/cnxk/cn9k_rx.h b/drivers/net/cnxk/cn9k_rx.h
index fa4efbf80a..c883eaeb07 100644
--- a/drivers/net/cnxk/cn9k_rx.h
+++ b/drivers/net/cnxk/cn9k_rx.h
@@ -345,13 +345,18 @@ cn9k_nix_cqe_to_mbuf(const struct nix_cqe_hdr_s *cq, const uint32_t tag,
 	mbuf->ol_flags = ol_flags;
 	*(uint64_t *)(&mbuf->rearm_data) = val;
 	mbuf->pkt_len = len;
-
-	if (flag & NIX_RX_MULTI_SEG_F) {
-		nix_cqe_xtract_mseg(rx, mbuf, val, flag);
-	} else {
-		mbuf->data_len = len;
+	mbuf->data_len = len;
+
+	if (flag & NIX_RX_MULTI_SEG_F)
+		/*
+		 * For multi segment packets, mbuf length correction according
+		 * to Rx timestamp length will be handled later during
+		 * timestamp data process.
+		 * Hence, flag argument is not required.
+		 */
+		nix_cqe_xtract_mseg(rx, mbuf, val, 0);
+	else
 		mbuf->next = NULL;
-	}
 }

 static inline uint16_t
@@ -414,7 +419,6 @@ cn9k_nix_recv_pkts(void *rx_queue, struct rte_mbuf **rx_pkts, uint16_t pkts,
 				     flags);
 		cnxk_nix_mbuf_to_tstamp(mbuf, rxq->tstamp,
 					(flags & NIX_RX_OFFLOAD_TSTAMP_F),
-					(flags & NIX_RX_MULTI_SEG_F),
 					(uint64_t *)((uint8_t *)mbuf
 								+ data_off));
 		rx_pkts[packets++] = mbuf;
diff --git a/drivers/net/cnxk/cnxk_ethdev.h b/drivers/net/cnxk/cnxk_ethdev.h
index 5bfda3d815..480cc6dfa4 100644
--- a/drivers/net/cnxk/cnxk_ethdev.h
+++ b/drivers/net/cnxk/cnxk_ethdev.h
@@ -685,14 +685,11 @@ cnxk_nix_timestamp_dynfield(struct rte_mbuf *mbuf,
 static __rte_always_inline void
 cnxk_nix_mbuf_to_tstamp(struct rte_mbuf *mbuf,
 			struct cnxk_timesync_info *tstamp,
-			const uint8_t ts_enable, const uint8_t mseg_enable,
-			uint64_t *tstamp_ptr)
+			const uint8_t ts_enable, uint64_t *tstamp_ptr)
 {
 	if (ts_enable) {
-		if (!mseg_enable) {
-			mbuf->pkt_len -= CNXK_NIX_TIMESYNC_RX_OFFSET;
-			mbuf->data_len -= CNXK_NIX_TIMESYNC_RX_OFFSET;
-		}
+		mbuf->pkt_len -= CNXK_NIX_TIMESYNC_RX_OFFSET;
+		mbuf->data_len -= CNXK_NIX_TIMESYNC_RX_OFFSET;

 		/* Reading the rx timestamp inserted by CGX, viz at
 		 * starting of the packet data.